<?php
session_start(['cookie_httponly' => true]); //TODO: php 7.3.0 add session.cookie_samesite here :>
error_reporting(0);
ini_set('display_errors', 0);

header('x-xss-protection: 1; mode=block');
header('X-Content-Type-Options: nosniff');
header('x-frame-options: DENY');
header('Referrer-Policy: no-referrer');
header("Content-Security-Policy: default-src 'none'; script-src 'sha256-Lc9AkWzww7M7xar+fIgE/Pj1DhkEmiIgBUe3e7XigSA=' 'sha256-CBbo3cXnDWRm8r8/+oIYgrU1L6drHSQAnQPJ6odoEtI=' https://code.jquery.com/jquery-3.3.1.js; img-src http: https:; style-src 'sha256-W75Hmmjzeqn6FZUlLRYchklGj3LzeQUnUzyoAdUIWDs=';");
header("Feature-Policy: geolocation 'none'; midi 'none'; sync-xhr 'none'; microphone 'none'; camera 'none'; magnetometer 'none'; gyroscope 'none'; speaker 'none'; fullscreen 'none'; payment 'none'; usb 'none'; vr 'none'; encrypted-media 'none'"); //hxp teaching new headers since forever https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Feature-Policy

function uuidv4() {
    return implode('-', [
        bin2hex(random_bytes(4)),
        bin2hex(random_bytes(2)),
        bin2hex(chr((ord(random_bytes(1)) & 0x0F) | 0x40)) . bin2hex(random_bytes(1)),
        bin2hex(chr((ord(random_bytes(1)) & 0x3F) | 0x80)) . bin2hex(random_bytes(1)),
        bin2hex(random_bytes(6))
    ]);
}

function e($str){
    return htmlspecialchars($str, ENT_QUOTES, 'UTF-8');
}

if(!isset($_SESSION['id'])){
    $_SESSION=['id' => uuidv4(), 'c' => uuidv4()];
}

$db = new mysqli('localhost', 'ublog', '__DB_PASSWORD__', 'ublog');
if ($db->connect_error) {
    die('Connection failed');
} 

if (isset($_POST['logo']) && isset($_POST['name']) && !empty($_POST['c']) && hash_equals($_SESSION['c'], $_POST['c'])){
    $stmt = $db->prepare('REPLACE INTO user(user_id, logo, name) VALUES (?,?,?)');
    $stmt->bind_param('sss', $_SESSION['id'], $_POST['logo'], $_POST['name']);
    $stmt->execute();
}

if (isset($_POST['text']) && isset($_POST['icon']) && !empty($_POST['c']) && hash_equals($_SESSION['c'], $_POST['c'])){
    $stmt = $db->prepare('INSERT INTO post(user_id, text, icon) VALUES (?,?,?)');
    $stmt->bind_param('sss', $_SESSION['id'], $_POST['text'], $_POST['icon']);
    $stmt->execute();
}

if (isset($_POST['report']) && !empty($_POST['c']) && hash_equals($_SESSION['c'], $_POST['c']) && preg_match('/^http:\/\/127.0.0.1\/\?id=[0-9a-f]{8}-[0-9a-f]{4}-[4][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}/', $_POST['report'])){
    include 'backend.php';
    send_to_admin($_POST['report']);
    exit();
}

$user_id = isset($_GET['id']) ? $_GET['id']: $_SESSION['id'];

$stmt = $db->prepare('SELECT id, text, icon FROM post WHERE user_id = ?');
$stmt->bind_param('s', $user_id);
$stmt->execute();
$result = $stmt->get_result();
$posts = [];
while ($row = $result->fetch_assoc()) {
    $row['url']= '/?id='.$user_id.'#post-'.$row['id'];
    $posts[] = $row;
}

$stmt = $db->prepare('SELECT logo, name from user where user_id = ?');
$stmt->bind_param('s', $user_id);
$stmt->execute();
$result = $stmt->get_result();
$logo = 'logo.png';
$name = 'hxp';
while ($row = $result->fetch_assoc()) {
    $logo = $row['logo'];
    $name = $row['name'];
}
?>
<!doctype html>
<html lang="en">
    <head>
        <meta charset=utf-8>
        <title>µblog</title>
        <style>
            @keyframes highlight {0% {background: #ffff99;} 100% {background: none;}}
            .highlight {animation: highlight 2s; animation-iteration-count: infinite;}
        </style>
    </head>
    <body data-posts="<?=e(json_encode($posts))?>" data-logo="<?=e($logo)?>" data-name="<?=e($name)?>" data-user-id="<?=e($_SESSION['id'])?>">
        <h1><span id="name"></span>'s µblog <img id="logo"></h1>
        <p>Finally a place to post your newest exploits, flags, or your thoughts about CTFs.</p>
        <div>
            <h2>Settings</h2>
            <form method="post"><input type="hidden" name="c" value="<?=e($_SESSION['c'])?>">
                <label>Name:</label>
                <input type="type" name="name" placeholder="hxp">
                <label>Logo:</label>
                <input type="text" placeholder="logo.png" name="logo">
                <input type="submit" value="Save">
            </form>
        </div>
        <hr>
        <div>
            <h2>Publish your own thoughts</h2>
            <form method="post"><input type="hidden" name="c" value="<?=e($_SESSION['c'])?>">
                <label>Text:</label>
                <textarea cols="128" placeholder="flags, exploits, etc." name="text"></textarea>
                <br>
                <label>Icon:</label>
                <input type="text" placeholder="icon.png" name="icon">
                <br> <!-- one day I will learn css -->
                <input type="submit" value="Post">
            </form>
        </div>
        <h2>Posts</h2>
        <div id="news-container"></div>
        <div>
            <h4>Report breakage to admin</h4>
            <form method="post"><input type="hidden" name="c" value="<?=e($_SESSION['c'])?>">
                <label>URL:</label><input type="type" name="report" placeholder="http://127.0.0.1/?id=..."><input type="submit" value="Report">
            </form>
        </div>
       <script src="https://code.jquery.com/jquery-3.3.1.js" integrity="sha256-2Kok7MbOyxpgUVvAk/HJ2jigOSYS2auK4Pfzbm7uH60=" crossorigin="anonymous"></script>
       <script>
            $('#logo').attr('src', $('body').data('logo'))
            $('#name').text($('body').data('name'))
        </script>
        <div  id="template" hidden>
            <div class="post">
                <div>
                    <img class="icon">
                </div>
                <div>
                    <p class="text"></p>
                </div>
                <div>
                    <a class="link">Link</a>
                </div>
            </div>
            <hr>
        <div>
        <script>
        if (!$('#news-container').html())
            $.each($('body').data('posts'),function(i,d) {
                $('#news-container').html($('#news-container').html()+$('#template').html() )
                $('#news-container .post:last .text ').text(d.text)
                $('#news-container .post:last .icon').attr("src",d.icon)
                $('#news-container .post:last .icon').attr("src",d.icon)
                $('#news-container .post:last .link').attr("href",d.url)
                $('#news-container .post:last').attr("id","post-"+d.id)
            })
            $(location.hash).addClass('highlight')
        </script>
    </body>
</html>